

//Created by Davidian Chorley 
//Controls a Canon or other camera's bulb shutter 
//Aug 11 2015
//This Code is in the public domain

//CODE NOTE version 0_1_17 is first with correct pin assignments for analogWrite and digitalRead
// CODE NOTE version 0_2_0 is first with some objective programming 
// CODE NOTE , move all led pins to serial - parallel converter chip, use pwm brightness control - put all led controls in objects

//write object to set all ledPins to LOW, call it just before setting a ledpin to HIGH in the button check routine.
//write 74hc595 serial interface to a) light button leds b) drive 7 segment interface + point led for 30 seconds + 1 avr pin for < 10 minutes   
//   ********   SETTING UP GLOBAL VARIABLES   ********   



// - - - - - - - - - - - !!!!!!! BUG CHECK !!!!!!! - - - - - - - - - - - 
//  BUG a. ?  sometimes pressing button causes a loop of 113 milliseconds   ????   loops through pause and Exposure HIGH loop   ????
//     fix this bug and write error catcher for very short intervals ( need variables to measure ACTUAL length of exposure and interval).
//  BUG b.    After button press,  exposure lights (LEDs) stay on until start of next Exposure loop or pause loop.  
//      cont...    need to make function call to clear leds and add it after each button press


//  BUG c.    not a bug - change    need to expres exposure length in a state machine, as well as lit leds and output to camera.
//  BUG d.    not a bug - change    need to make all routines into functions and call from void loop.    code is too messy and hard to read / repair as is.
//  BUG e.    not a bug - change    need to make an array for leds, in led clearing function loop through used LEDs 



//     - - - - - - - - VERSION 2 - - - - - - - - 

 //digitalWrite for class LedOn, , need to initialize pins as digital or pins act as pwm unless set to 0 by analogWrite. Unreliable in future software versions and on other devices.


//small -  cheap oled or similar screen, very dimmable. 
//displays exposure time, cumulative exposure time, exposure #. ( duration of film at 30 frames a second? )
//can do repeated sequences of different exposures
//can do bursts of exposures at intervals - also can trigger camera for short exposures, planetary photography
//displays present and next exposure time, time to start next exposure in sequence
// 2 button navigation on screen, one endlessly turnable sensor for input.
//    *******    LED dims to 0 until object approaches screen ( ir proximity sensor)    ********

//     - - - -  Hardware - code - change - - - - -
/*    brightness of all leds controlled through one analog pin, through transistor on ground, and 
        resistor on ground to add further dimming ( not to protect from overcurrent ) - variable resitor until value is found*/    
/*    brightness of LED display also on same pin or other pin.  seperate resistor to dim to similar brightness*/

/*    sky brightness sensor to stop - or change to shorter exposures, camera when 
          sky brightens or during fireball or accident with flashlight*/
 /* aforementioned proximity sensor to dim LEDs when no one is close - not funstioning in bright enviroments*/
 /* use second analog pin with no resistor to ground  for LED control in bright enviroments*/
 /*  ???   change to additive buttons?? ( 15 sec ? ) +30sec + 1 min + 2 min + 4 min + 8 min ( + 16 min & ) ??
or plus minus 30 or 15 sec increments    */




//series of buttons starts timed exposures of 30 seconds, 1 minute 1.5 minutes 2.5 minutes 4 minutes 6.5 minutes
const int button1 = 14; // press to start 30 second exposure sequence
const int button2 = 15; // press to start 1 minute exposure
const int button3 = 16; // press to start 1 minute and 30 second exposure
const int button4 = 17; // press to start 2 minute and 30 second exposure
const int button5 = 18; // press to start 4 minute exposure
const int button6 = 19; // press to start 6 minute exposure

//series of LEDs to show duration of exposure - use K ohm resistor to limit brightness
//replace this with function to control 7 seg LED, use avr pin to indicate 10 minute+, analog pin to control brightness via pin 134 of 74hc595
const int led1 = 3;  // lights to show 30 second exposure
const int led2 = 5;  // lights to show 1 minute exposure
const int led3 = 6;  // lights to show 1 minute and 30 second exposure
const int led4 = 9; // lights to show 2 minute and 30 second exposure
const int led5 = 10; // lights to show 4 minute exposure
const int led6 = 11; // lights to show 6 minute exposure


//sequence of exposure times to match buttons and leds
//const int replaced by int in future versions with more extensive exposure times
const unsigned long exposure1 = 30000;   // 30 seconds = 30,000 milliseconds
const unsigned long exposure2 = 60000;   // 60 sec = 1 minute = 60,000 mill
const unsigned long exposure3 = 90000;   // 90 sec = 1,1/2 min, 90,000 mill
const unsigned long exposure4 = 150000;  // 150 sec = 2,1/2 min = 150,000 mill
const unsigned long exposure5 = 240000;  // 240 sec = 4 min = 240,000 mill
const unsigned long exposure6 = 360000;  // 360 sec = 6 min = 360,000 mill

unsigned long exposureInterval = 0;  // TEST ONLY timefrom start of one frame to next 
int ledOn = 1; // brilliance of display leds, keep dim
int ledOff = 0;       // set leds to off or low


//future option, toggle button / led to select sequence or single shot

// camera shutterPin outout
const int shutterPin = 4;
// shutterPin state - shutter LOW or HIGH
int shutterState = LOW;

// timing variable, will store time exposure was started
unsigned long previousTime = millis();
// timing variable. reads current time
unsigned long currentTime = millis();
// timing variable, will store the exposure time in milliseconds
unsigned long exposureTime = 0;
//timing variable, stores interval bettween frames time in milliseconds
unsigned long pause = 1000;

/***************************************** Initialize class' here *****************************************/

class LedOn                            //class turns on one ledpin, turns off all others
  {
      // Class Member Variables
	// These are initialized at startup
        // define pin# for LEDs
        int const ledPin1 = 3;      //variables for led output pins create relationship to variable led1
        int const ledPin2 = 5;
        int const ledPin3 = 6;
        int const ledPin4 = 9;
        int const ledPin5 = 10;
        int const ledPin6 = 11;
        int const ledPin7 = 13;
                              // state variables for state on or off of LEDs, initalized LOW
        int stateLed1 = LOW;
        int stateLed2 = LOW;
        int stateLed3 = LOW;
        int stateLed4 = LOW;
        int stateLed5 = LOW;
        int stateLed6 = LOW;
        int stateLed7 = LOW;
        
                              // LED state is set LOW, HIGH, with digitalWrite. brightness controlled by analogWrite and transistor across LED ground
        
    public:
    LedOn(int pinOn)         //CONSTRUCTOR -- call to  Class ledOn sends led # to turn on - which to turn off determined in constructor
    {                        // define variables, set pin state /input /output etc.
        
        if (pinOn == 0) {
          //nothing much changes ?   all stateLed variables set to "LOW" already.
        }        
        
        if (pinOn == 1) {
          stateLed1 = HIGH;
        }

        if (pinOn == 2) {
          stateLed2 = HIGH;
        }

        if (pinOn == 3) {
          stateLed3 = HIGH;
        }

        if (pinOn == 4) {
          stateLed4 = HIGH;
        }

        if (pinOn == 5) {
          stateLed5 = HIGH;
        }

        if (pinOn == 6) {
          stateLed6 = HIGH;
        }

        if (pinOn == 7) {
          stateLed7 = HIGH;
        }

    }
    
     void On()              //FUNCTION -- turn on pinOn, change all other ledPins to LOW
       {
       digitalWrite(ledPin1, stateLed1);    //relplace with ooutput to 74h595/596 ?
       digitalWrite(ledPin2, stateLed2);
       digitalWrite(ledPin3, stateLed3);
       digitalWrite(ledPin4, stateLed4);
       digitalWrite(ledPin5, stateLed5);
       digitalWrite(ledPin6, stateLed6);
       digitalWrite(ledPin7, stateLed7);
          
          
       }
  };
  
  
  //              sends members to constructor
  LedOn ledsOff(0);
  LedOn ledOne(1);
  LedOn ledTwo(2);
  LedOn ledThree(3);
  LedOn ledFour(4);
  LedOn ledFive(5);
  LedOn ledSix(6);
  LedOn ledSeven(7);    //set LOW with others to turn off LED on arduino Boards
  
/*******************************************  class' Initialized *******************************************/

// ---------------  ********   VOID SETUP HERE    ****    SET UP I-O PINS  ********   ----------------

void setup() {
  
// TEST PURPOSES ONLY REMOVE BEFOR FINAL VERSION - - - - - - - - - - - - - - - - - - - - 
  // open serial interface for debugging
  Serial.begin(9600);
// TEST PURPOSES ONLY REMOVE BEFOR FINAL VERSION - - - - - - - - - - - - - - - - - - - - 


  
 //set start pin 
 pinMode(button1, INPUT_PULLUP); // press to start 30 second exposure sequence 
 pinMode(button2, INPUT_PULLUP); // press to start 1 minute exposure
 pinMode(button3, INPUT_PULLUP); // press to start 1 minute and 30 second exposure
 pinMode(button4, INPUT_PULLUP); // press to start 2 minute and 30 second exposure
 pinMode(button5, INPUT_PULLUP); // press to start 4 minute exposure
 pinMode(button6, INPUT_PULLUP); // press to start 6 minute exposure

//series of LEDs to show duration of exposure - use PWM on transistor across ground to limit brightness
 pinMode(led1, OUTPUT); // lights to show 30 second exposure sequence
 pinMode(led2, OUTPUT); // lights to show 1 minute exposure
 pinMode(led3, OUTPUT); // lights to show 1 minute and 30 second exposure
 pinMode(led4, OUTPUT); // lights to show 2 minute and 30 second exposure
 pinMode(led5, OUTPUT); // lights to show 4 minute exposure
 pinMode(led6, OUTPUT); // lights to show 6 minute exposure
 
 //digitalWrite for class LedOn, , need to initialize pins as digital or pins act as pwm unless set to 0 by analogWrite. Unreliable in future software versions and on other devices.


//Set the bulb exposure control pin
pinMode(shutterPin, OUTPUT);

}
// **** end of VOID SETUP ****


//    --------------- ******** ******** ******** ********   VOID LOOP HERE   ******** ******** ******** ******** ----------------

void loop() {

  Serial.println("Start void loop, ");

  
  

  
  /* (2a)Turn off LEDs //Code commented out --- check for logic bugs before removine TEST
  //ledsOff.On();
  
  
  // (2b) Set correct LED
  
  exposureInterval  = exposureTime + pause;
  
  if(exposureInterval == exposure1) {ledOne.On();
  }
    if(exposureInterval == exposure2) {ledTwo.On();  
    }
      if(exposureInterval == exposure3) {ledThree.On();
      }
        if(exposureInterval == exposure4) {ledFour.On();
        }
           if(exposureInterval == exposure5) {ledFive.On();
           }
             if(exposureInterval == exposure6) {ledSix.On();
             }
             
             // (2end)**** **** END OF CLEAR LEDs **** ****
  
      */ //TEST end
      
      
 //  (1a) ****RESET THE CLOCK FOR PAUSE****
   previousTime = millis();
   
   
// TEST PURPOSES ONLY REMOVE BEFOR FINAL VERSION - - - - - - - - - - - - - - - - - - - - 
 exposureInterval  = exposureTime + pause;
 Serial.print("time = ");
  Serial.print(previousTime);
   Serial.print(" / exposureTime = ");
    Serial.print(exposureTime);
     Serial.print(" / exposureInterval  = ");
      Serial.println(exposureInterval); 
// TEST PURPOSES ONLY REMOVE BEFOR FINAL VERSION - - - - - - - - - - - - - - - - - - - - 


   
   
 //  (1b)   ********     ********     PAUSE LOOP     *********     ********
 while(pause >= currentTime - previousTime) {
   digitalWrite(shutterPin, LOW);

     currentTime = millis();     //set CLOCK IN PAUSE LOOP 
   
   //(1c) - - - - - - - - - - - write button check CLASS call to replace this , and share with exposure loop - - - - - - - - - - - - -
   //read buttons to set exposure time, don't set shutterPin high yet...
  if (digitalRead(button1) == LOW) {exposureTime = exposure1 - pause;
   ledOne.On();
  } //set exposure to 30 seconds
if (digitalRead(button2) == LOW) {exposureTime = exposure2 - pause;
  ledTwo.On();
  } //set exposure to 1 minute
if (digitalRead(button3) == LOW) {exposureTime = exposure3 - pause;
  ledThree.On();
  } //set exposure to 1 1/2 minutes
if (digitalRead(button4) == LOW) {exposureTime = exposure4 - pause;
  ledFour.On();
  } //set exposure to 2 1/2 minutes
if (digitalRead(button5) == LOW) {exposureTime = exposure5 - pause;
  ledFive.On();
  } //set exposure to 4 minutes
if (digitalRead(button6) == LOW) {exposureTime = exposure6 - pause;
  ledSix.On();
  } //set exposure to 6 minutes
  

 }  // (1end) ********** ******** END OF PAUSE LOOP ******** **********
 
 
 
 
  
  //  (3b)  **** check to see if program should start exposure, !!!!!!!! START EXPOSURE HERE IF TRUE !!!!!!!! ****
  if (exposureTime > 0) { 
    digitalWrite(shutterPin, HIGH);
    //YAY , DOING SOME REAL WORK FINALLY !!!!!!!
// NOTE!  create state variable with TRUE FLASE properties, set true if exposing, false if pausing or waiting for input.  us if ( exposing or pausing has finsished) {var = !var} to change truth
//NOTE!    use truth of var above to set output to camera   eg.  ...    digitalWrite(cameraOutput, var)

// TEST PURPOSES ONLY REMOVE BEFOR FINAL VERSION - - - - - - - - - - - - - - - - - - - - 

  Serial.println("Start Exposure loop, ");

// TEST PURPOSES ONLY REMOVE BEFOR FINAL VERSION - - - - - - - - - - - - - - - - - - - - 



  //  (3c)  ******** ********    EXPOSURE HIGH LOOP  ********  ********
  //    (exposureNow)
 while(exposureTime >= currentTime - previousTime) {
    
    
    //check clock for exposure HIGH loop
    currentTime = millis();

  
  // (buttonCheck) read start buttons and reset exposure interval if changed during current exposure
  //write object ((buttonCheck)) to set the correct LEDs to HIGH  - maybe analog, bright when pressed, dimmer when running

  //set exposure to exposure1 (30 seconds)
if (digitalRead(button1) == LOW) {exposureTime = exposure1 - pause;
  ledOne.On();
   digitalWrite(shutterPin, HIGH);
  } 
  //set exposure to exposure2 (1 minute)
if (digitalRead(button2) == LOW) {exposureTime = exposure2 - pause;
  ledTwo.On();
   digitalWrite(shutterPin, HIGH);
  }
  //set exposure to 1 1/2 minutes
if (digitalRead(button3) == LOW) {exposureTime = exposure3 - pause;
  ledThree.On();
   digitalWrite(shutterPin, HIGH);
  }
  //set exposure to 2 1/2 minutes
if (digitalRead(button4) == LOW) {exposureTime = exposure4 - pause;
  ledFour.On();
   digitalWrite(shutterPin, HIGH);
  }
  //set exposure to 4 minutes
if (digitalRead(button5) == LOW) {exposureTime = exposure5 - pause;
  ledFive.On();
   digitalWrite(shutterPin, HIGH);
  }
 //set exposure to 6 minutes
  if (digitalRead(button6) == LOW) {exposureTime = exposure6 - pause;
  ledSix.On();
   digitalWrite(shutterPin, HIGH);
  }

      } // (3end)**** **** END OF EXPOSURE HIGH LOOP **** ****
  }
  
  
 // **** SET EXPOSURE PIN LOW FOR SURETY ****
 digitalWrite(shutterPin, LOW);

  
}//  *********  ********  END OF VOID LOOP ********* *********
